EnergyMission.Web/Controllers/TeamManagersController.cs
using System;
using System.Collections.Generic;
using System.Web.Mvc;
using AutoMapper;
using EnergyMission.Domain.ClientAdministrator;
using EnergyMission.Web.ViewModels.ClientAdministrator;
using EnergyMission.Data.IRepostitories;
using EnergyMission.Domain.Entities;
using EnergyMission.Web.Authentication;
using System.Threading.Tasks;
using System.Linq;
using Microsoft.AspNet.Identity;
using EnergyMission.Web._Framework;
using Microsoft.AspNet.Identity.EntityFramework;
namespace EnergyMission.Web.Controllers
{
    public class TeamManagersController :EmControllerBase
    {
        //private readonly IClientAdministratorAppService _ClientAdministratorAppService;
        private readonly IRepository<Data.ClientTeamManager> _ClientManagerAppService;
        private readonly IRepository<Data.ClientAdministrator> _ClientAdminstrator;
        private readonly IRepository<Data.Person> _PesonAppService;
        /// <summary>
        ///     Class constructor
        /// </summary>
        /// <param name="aClientAdministratorAppService">Application service for ClientAdministrator</param>
        public TeamManagersController()
        {
            ViewBag.PageTitle = "Client Administrators";
            _ClientManagerAppService = new EnergyMission.Data.Repositories.Repository<Data.ClientTeamManager>();
            _PesonAppService = new EnergyMission.Data.Repositories.Repository<Data.Person>();
            _ClientAdminstrator = new EnergyMission.Data.Repositories.Repository<Data.ClientAdministrator>();
        }

        /// <summary>
        ///     Called when we want to CREATE a ClientAdministrator in the database.
        /// </summary>
        /// <param name="aClientAdministrator">Information about the ClientAdministrator to create.</param>
        /// <returns>Returns gridview on success, create ClientAdministrator view on failure.</returns>
        //[AcceptVerbs(HttpVerbs.Post)]
        //public override ActionResult Create(ClientAdministratorAddEditViewModel aClientAdministrator)
        //{
        //    if (ModelState.IsValid)
        //    {
        //        try
        //        {
        //            _ClientAdministratorAppService.InsertClientAdministrator(Mapper.Map<InsertClientAdministratorInput>(aClientAdministrator.ClientAdministrator));
        //            return RedirectToAction("Index");
        //        }
        //        catch (Exception e)
        //        {
        //            StatusMessageError(e.Message);
        //        }
        //    }
        //    else
        //        StatusMessageErrorsModelState(ModelState);

        //    return View("Create", aClientAdministrator);
        //}



        [AcceptVerbs(HttpVerbs.Post)]
        public  ActionResult Creates(ClientTeamManagerEntity aClientAdministrator)
        {
            if (ModelState.IsValid)
            {
                try

                {
                     ApplicationUser loggedInUser = AppUserManager.GetLoggedInUser();


                     var value = _ClientManagerAppService.Wheres(tt => tt.PersonId == aClientAdministrator.PersonId);
                    if (aClientAdministrator.Id == 0)
                    {


           
                           if (value == null)
                           {
                               aClientAdministrator.ClientId = loggedInUser.UserProfileInformations.ClientId.Value;
                               aClientAdministrator.CreationTime = DateTime.Now;
                               aClientAdministrator.CreatorUserId = loggedInUser.UserProfileInformations.PersonId.Value;
                               _ClientManagerAppService.Insert(Mapper.Map<Data.ClientTeamManager>(aClientAdministrator));
                               Data.Person pres = _PesonAppService.SelectByID(aClientAdministrator.PersonId);
                               ApplicationUser apps = AppUserManager.FindByName(pres.EmailAddress);

                               AppUserManager.RemoveFromRole(apps.Id, "Team Manager");
                               AppUserManager.AddToRole(apps.Id, "Team Manager");
                               //Data.Person pres = _PesonAppService.SelectByID(aClientAdministrator.PersonId);
                               //ApplicationUser apps = AppUserManager.FindByName(pres.EmailAddress);
                               //AppUserManager.AddToRole(apps.Id, "Administrator");
                           }

                        
 
                           else
                           {

                               TempData["msg"] = "Allready Assigned";

                           }
                    }
                    else

                    {
                      
                        if (value == null)
                        {


                            ClientTeamManagerEntity clientadminstrator = new ClientTeamManagerEntity();
                            clientadminstrator = Mapper.Map<ClientTeamManagerEntity>(_ClientManagerAppService.SelectByID(aClientAdministrator.Id));

                            clientadminstrator.ClientId = loggedInUser.UserProfileInformations.ClientId.Value;


                            clientadminstrator.LastModificationTime = DateTime.Now;
                            clientadminstrator.LastModifierUserId = loggedInUser.UserProfileInformations.PersonId.Value;
                            _ClientManagerAppService.Update(Mapper.Map<Data.ClientTeamManager>(clientadminstrator));
                            Data.Person pres = _PesonAppService.SelectByID(clientadminstrator.PersonId);
                            ApplicationUser apps = AppUserManager.FindByName(pres.EmailAddress);

                            AppUserManager.RemoveFromRole(apps.Id, "Team Manager");
                            AppUserManager.AddToRole(apps.Id, "Team Manager");
                        }

                        else

                        {

                            TempData["msg"] = "Allready Assigned";

                        }
                    
                    }
                    return RedirectToAction("Index");
                }
                catch (Exception e)
                {
                    StatusMessageError(e.Message);
                }
            }
            else
                StatusMessageErrorsModelState(ModelState);

            return View("Index");
        }
        /// <summary>
        ///     Called when we want to DELETE the ClientAdministrator.
        /// </summary>
        /// <param name="Id">Unique identifier for the ClientAdministrator record to delete.</param>
        /// <returns>Returns the grid view on success, error otherwise.</returns>
        public  ActionResult Delete(long Id)
        {
            if (Id >= 0)
            {
                try
                {
                    ApplicationUser loggedInUser = AppUserManager.GetLoggedInUser();
                    Data.ClientTeamManager clientadminstrator = new Data.ClientTeamManager();
                 clientadminstrator = _ClientManagerAppService.SelectByID(Id);
                 clientadminstrator.IsDeleted = true;
                 clientadminstrator.LastModificationTime = DateTime.Now;
                 clientadminstrator.LastModifierUserId = loggedInUser.UserProfileInformations.PersonId.Value;
                 _ClientManagerAppService.Update(clientadminstrator);
                Data.Person pres = _PesonAppService.SelectByID(clientadminstrator.PersonId);
                ApplicationUser apps = AppUserManager.FindByName(pres.EmailAddress);
                AppUserManager.RemoveFromRole(apps.Id, "Team Manager");
                }
                catch (Exception e)
                {
                    StatusMessageError(e.Message);
                }
            }
            return RedirectToAction("GridViewPartial");
        }

        /// <summary>
        ///     Called when Edit is clicked in the GridView.
        /// </summary>
        /// <param name="Id">Unique identifier for the record to edit.</param>
        /// <returns>Returns the edit view on view on success, error on failure.</returns>
        //public override ActionResult Edit(long Id)
        //{
        //    ViewBag.PageTitle = "Edit Client Administrator";

        //    ClientAdministratorAddEditViewModel viewModel = new ClientAdministratorAddEditViewModel
        //    {
        //        ClientAdministrator = _ClientAdministratorAppService.GetClientAdministratorWithInclude(new GetClientAdministratorInput {Id = Id})
        //    };

        //    return View("Edit", viewModel);
        //}
          public  JsonResult Edits(long Id)
        {

            IQueryable<Data.ClientTeamManager> SSB = _ClientManagerAppService.Where(tt => tt.Id == Id);

            var res = (from sub in SSB
                      
                       select new
                       {
                           id = sub.Id,
                           personid = sub.PersonId
                       }
                                       );



            return Json(res, JsonRequestBehavior.AllowGet);

   //             var result = _ClientAdministratorAppService.SelectByID(Id);
   ////var x = from i in _ClientAppService.GetClientById(Id)
   ////                 select new { result.StateId, result.Id, result.Name, result.NOE, result.SuperAdminEmail, result.PostCodeId, result.City, result.Address, result.Geo_location_Latitude, result.Geo_location_Longditude};
   //         return Json(result, JsonRequestBehavior.AllowGet);


        }
        /// <summary>
        ///     Displays the view that contains only the grid view.
        /// </summary>
        /// <returns>Returns the view containing the grid view.</returns>
        [ValidateInput(false)]
        public  ActionResult GridViewPartial()
        {
            return PartialView("_GridViewPartial", RetrieveAllClientAdministrators());
        }

        /// <summary>

EnergyMission.Web/Views/TeamManagers/Create.cshtml
@model EnergyMission.Web.ViewModels.ClientAdministrator.ClientAdministratorAddEditViewModel

@Html.Partial("_AddEditPartial", Model, new ViewDataDictionary { { "ActionName", "Create" } })

EnergyMission.Web/Views/TeamManagers/Edit.cshtml
@model EnergyMission.Web.ViewModels.ClientAdministrator.ClientAdministratorAddEditViewModel

@Html.Partial("_AddEditPartial", Model, new ViewDataDictionary { { "ActionName", "Update" } })

EnergyMission.Web/Views/TeamManagers/Index.cshtml
@model IEnumerable<EnergyMission.Domain.Entities.ClientTeamManagerEntity>
@{
    
    EnergyMission.Domain.Entities.ClientTeamManagerEntity ClientTeamManager = new ClientTeamManagerEntity();
    
}
@section Scripts{

<script>

    
    $(document).ready(function () {
        var value = "@ViewBag.msg";
        if (value == "")
        {
            $("#errorssms").hide();
        
        
        }
        else 
        {
            $("#errorssms").show();
        
        
        }
        $('#confname').change(function () {

            var Name1 = $("#confname").val().toUpperCase();

            var value=[];

            $("#PersonId option").each(function (i) {

                value[i] = $(this).text().toUpperCase();
                //alert($(this).text() + " : " + $(this).val());
            });


            //var item = jQuery.inArray(Name1, value);
            //alert(item);

            if (jQuery.inArray(Name1, value) == -1) {
                $("#lblval").text("Name not found");
                return;

            }
            else {

                $("#lblval").text('');
                return;
            }




        });
    });
    ////$(function () {
    //    $("#txtconf").change(function () {
    //        alert("hi");
    //        var ddlFruits = $("#Name");
    //        if (ddlFruits.val() == "") {
    //            //If the "Please Select" option is selected display error.
    //            alert("Please select an option!");
    //            return false;
    //        }
    //        return true;
    //    });
    //});
    //$(document).ready(function () {
    //    $('#NameConfirm').change(function () {



    //        var value = $("#Name").val();
    //        alert(value);


    //    });
    //});
    function cancelall()
    {


        $("#id").val('');
        $("#PersonId").val('');
        $("#empid").val('');

        //$("#EmailAddress").val('');
        //$("#password").val('');
        //$("#PasswordConfirm").val('');
        //$("#CVUrl").text('');


        return false;
    }

    var selectedKeys = "";

    function aspxSEClick(selectedValues) {
  
        var value = selectedValues;

        $.ajax({
                type: "Get",
                url: "/TeamManagers/Edits",
                data: { "Id": value },
                dataType: 'json',
                contentType: "application/json;charset=utf-8",
                success: function (data) {

                    //var ID       = JSON.stringify(data);
                    //alert(ID);
                     $("#Id").val(data.result[0].id);
                     $("#PersonId").val(data.result[0].personid);
                     $("#empid").val(data.result[0].personid);
                     //$("#empid").val(data.result[0].name);
                    //$("#editmodel").show();
                    //$("#SuperAdminEmail").val(data.result.superAdminEmail);
                    //$("#NOE").val(data.result.noe);
                    //$("#btnsave").val("Edit");
                    //$("#sorganization").html(data.result.name);
                    //$("#snoe").html(data.result.noe);
                    //$("#sclinetid").html(data.result.clientAdmin);
                    //$("#ClientAdmin").val(data.result.clientAdmin);
                    //$("#Address").val(data.result.address);
                    //$("#saddress").html(data.result.address);
                    //$("#City").val(data.result.city);
                    //$("#StateId").val(data.result.stateId);
                    //$("#postCodeId").val(data.result.postCodeId);
                    //$("#spostcode").html(data.result.city + "," + $("#StateId").text() + "," + $("#postCodeId").text());
                    //$("#Geo_location_Latitude").val(data.result.geo_location_Latitude);
                    //$("#Geo_location_Longditude").val(data.result.geo_location_Longditude);
                    //$("#sgeolocation").html(data.result.geo_location_Latitude);
                    //$("#sgeolocation1").html(data.result.geo_location_Longditude);

                    return false;
                },


                error: function (textStatus, errorThrown)
                {

                    alert(textStatus);
                }
            });

        //for (var i in selectedValues) {
        //    selectedKeys = selectedKeys + selectedValues[i] + ";";
        //}

        //gvRequestsList.PerformCallback();
    }
</script>
    }
<div class="second-menu">
    <h3>Manager Roles</h3>
    @*<ul class="org-inner-menu">
        <li><a href="#">Contact Site Manager</a></li>
        <li><a href="#">Help</a></li>
        <li><a href="#">Report Error</a></li>
        <li><a href="#">Report Error</a></li>
    </ul>*@
</div>

<div class="examples">
    <div id="testDivNested">
        <div class="gray_bg">
            <div class="ensure2" id="errorssms"><i class="fa fa-check-circle" aria-hidden="true"></i> @ViewBag.msg</div>

        
            <!-- Start White Inner -->
            <div class="white_inner">
           
                <div class="client-admin-login">
                    @Html.Action("GridViewPartial")
                    @*<a href="/persons/Create" id="Addperson" class="add_new">Add New person</a>*@
                    </div>

           
                    @*<a href="Javascript:visible();" id="Addclient" class="add_new">Add New Client</a>

            <*@
                </div>
                    @*<div class="top_name">
                            <ul>
                                <li>Countries</li>
                            </ul>
                        </div>
                        <div id="testDiv1">
                            <div class="inner">
                                <div class="row_client">
                                    <span class="black">Australia</span>
                                    <span class="edit"><a href="#">Edit</a></span>
                                    <span class="delete"><a href="#">Delete</a></span>
                                </div>
                            </div>
                        </div>*@
     
                <!-- End Countries -->

      
            <!-- End White Inner -->
            <!-- Start Bottom Details -->
            <div class="bottom delete2">

                @Html.Partial("_AddEditPartial", ClientTeamManager)


            </div>
        </div>
        <!-- End Bottom Details -->
    </div>
</div>

EnergyMission.Web/Views/TeamManagers/_AddEditPartial.cshtml
@model EnergyMission.Domain.Entities.ClientTeamManagerEntity
@{
    string actionName = (string)ViewData["ActionName"];
    EnergyMission.Web.Common.Common cs = new EnergyMission.Web.Common.Common();
}
@using (Html.BeginForm("Creates", "TeamManagers", FormMethod.Post))
{
    @Html.AntiForgeryToken()
    @Html.HiddenFor(model => model.Id)
    
   
    <div class="left">




        <div id="viewmodel">
     


            <label class="name">  Person</label>
            <div class="type-contry">
                @Html.DropDownListFor(model => model.PersonId, @ViewBag.pesonal as SelectList,"Select", new { @class = "select-btn" })
                @*<input type="text" name="name" value="" placeholder="" />*@

                <div class="error-msg">
                    @*<span class="cross-icon eql_height "><img src="~/Content/themes/base/images/error-arrow-2.png" alt=""></span>*@
                    <span class="error"> @Html.ValidationMessageFor(tt => tt.PersonId, "", new { @class = "error-message eql_height" })</span>
                </div>  
            </div>
            <div class="type-contry">
                <label class="name">Or </label>
              </div>
                <div class="clearfix"></div>
                <label class="name">Emp ID</label>
                @Html.DropDownListFor(model => model.PersonId, @ViewBag.emp as SelectList, "Select", new { @class = "select-btn" })
            </div>

        <input class="save button" name="button" type="submit" value="Assign Admin" />
        <input class="done button" name="button" onclick="cancelall();" type="button" value="Done" />
    </div>
    <div class="right" style="margin-top:25px; color:red;">

            <span class="error " > <label id="lblval" class="error-message eql_height"></label> </span>
    </div>
}

EnergyMission.Web/Views/TeamManagers/_GridViewPartial.cshtml
@using EnergyMission

@Html.DevExpress().GridView(settings =>
{
    GridViewSettingsHelper.GridViewSettingsDefaults("gvSettingsManagerRoles", "ManagerRoles", Ajax, Html, ViewContext, settings);
    settings.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;
    settings.CallbackRouteValues = new { Controller = "TeamManagers", Action = "GridViewPartial" };
    //settings.Settings.VerticalScrollableHeight = 200;

    settings.Columns.Add("Person.persons").Caption = "Manager";
    settings.Columns.Add("Person.EmailAddress").Caption = "Email address";

    settings.Columns.Add(column =>
    {
        //column.FieldName = "Id";

        column.SetDataItemTemplateContent(c =>
        {


            int value = Convert.ToInt32(DataBinder.Eval(c.DataItem, "Person.Status"));
            string classs = "";
            if (value == 0)
            {
                classs = "fa fa-long-arrow-left";


            }
            else if (value == 1)
            {
                classs = "fa fa-long-arrow-right";

            }

            else if (value == 2)
            {
                classs = "fa fa-check";
            }
            else if (value == 3)
            {
                classs = "fa fa-check";
            }
            else
            {
                classs = "fa fa-check";

            }
            ViewContext.Writer.Write(String.Format("<span class='verified'> <a herf='#'> <i class='" + classs + "' > </i></a> </span>"));
            
           
            ViewContext.Writer.Write(

                 Ajax.ActionLink("Delete", "Delete", "TeamManagers",
                        new
                        {
                            Id = DataBinder.Eval(c.DataItem, "Id"),
                            @style = "color:#eb4d4e"
                        },
                        new AjaxOptions
                        {
                            Confirm = "Delete this record?",
                            HttpMethod = "DELETE",
                            OnSuccess = "OnSuccess(data, 'gvSettingsManagerRoles')"
                        }) + "&nbsp;"

               );
            ViewContext.Writer.Write(String.Format("<div class='popup'> <span class='status'>Verification Status</span><ul> <li><i class='fa fa-long-arrow-left'></i> Request Verification</li><li><i class='fa fa-check'></i> Varified</li><li><i class='fa fa-close'></i> Not Varified</li></ul></div>"));



        });
    });

}).Bind(Model).GetHtml()

@*<li><i class='fa fa-question'></i> Unknown</li>*@

@*<li><i class='fa fa-long-arrow-right'></i> Awaiting Response</li>*@